.\" Process this file with groff -man -Tascii hed.1
.\"
.\" Bold list, separated by commas.
.de BL
.  ds result \&\"
.  while (\\n[.$] >= 2) \{\
.    as result \fB\\$1\fR, \"
.    shift
.  \}
.  if \\n[.$] .as result \fB\\$1
\\*[result]
.  ft R
..
.TH HED 1 "2012 October 12"
.SH NAME
hed \- a visual hexadecimal editor
.SH SYNOPSIS
.B hed
[options]
file
.SH DESCRIPTION
.B Hed
is a terminal hexadecimal editor with \fBvim\fP-like controls which can
edit arbitrarily large files.

.SH OPTIONS

.TP
.BL --normal
Start in the N(ormal) mode (default, ASCII input is not taken as the data
to be written but as controls, \f2vi\f1-like).
.TP
.BL -i --insert
Start in the I(insert) mode instead of the default N(ormal) mode - ASCII
input is taken as the data to be written, and are inserted in front of
the already present data.
.TP
.BL -r --replace
Start in the R(eplace) mode instead of the default N(ormal) mode - ASCII
input is taken as the data to be written, and are overwriting the already
present data.
.TP
.BL -s --spread
Spread the file content viewport to fully fit the terminal width. The
default style is to keep the line width a multiple of 0x10.
.TP
.BL --play
Replay the argument value as \fBhed\fP keyboard input, taken verbatim. If
you won't make \fBhed\fP quit by the input fed to it, it will be available
for user control after replaying the queued keypresses.
.TP
.BL -h --help
Show a short usage information.
.TP
.BL -V --version
Show the program version and basic licence information.

.SH CONTROLS

.PD 0
.TP 5
.BL R e
Switch to the R(eplace) mode.
.TP
.BL i
Switch to the I(nsert) mode.
.TP
.BL Ins
Switch to the I(nsert) mode, or to the R(eplace) mode if already there.
.TP
.BL Esc
Switch to the N(ormal) mode.
.TP
.BL Tab
Switch between the hexadecimal and ASCII column.
.TP
.BL h j k l
Move cursor left, down, up or right respectively.
.TP
.B Arrow keys
Move cursor appropriately.
.TP
.BL Home gg
Move cursor to the start of the file.
.TP
.BL End G
Move cursor to the end of the file.
.TP
.BL ^
Move cursor to the start of the line.
.TP
.BL $
Move cursor to the end of the line.
.TP
.BL PageUp Ctrl-B
Move cursor one page up.
.TP
.BL PageDown Ctrl-F
Move cursor one page down.
.TP
.BL :
Enter an extended command (see
.SB EXMODE
below).
.TP
.BL #
Jump to the specified offset with the cursor. The offset is an expression
(see
.SB EXPRESSIONS
below; for starters, just type a decimal, octal or hexadecimal number).
.TP
.BL /
Forward search the specified expression in the file (see
.SB EXPRESSIONS
below).
.TP
.BL ?
Backwards search the specified expression in the file (see
.SB EXPRESSIONS
below).
.TP
.BL n
Next search match.
.TP
.BL N
Previous search match.
.TP
.BI """" x
Select register \fIx\fP (letter, digit, ").
.TP
.BL y
Yank visual region to selected register.
.TP
.BL d
Delete visual region and save it to selected register.
.TP
.BL p
Put selected register after cursor. If a visual region is selected,
its contents is exchanged with the register.
.TP
.BL P
Put selected register before cursor. If a visual region is selected,
its contents is exchanged with the register.
.TP
.BL o
Overwrite buffer portion at the cursor by contents of selected register;
the buffer portion is either as big as the register was, or bounded
by selected region if in visual mode.
.TP
.BI m x
Put a mark \fIx\fP at the current cursor position.
.TP
.BI ' x
Jump at mark \fIx\fP.
.TP
.BL Ctrl-Y
Move the viewport one line up.
.TP
.BL Ctrl-E
Move the viewport one line down.
.TP
.BL r
Replace the character under the cursor with the character specified
next (pressed key in the ASCII column, typed hexadecimal digit in
the hex column).
.TP
.BL x Del
Delete the byte on the cursor, moving the rest of the file
left by a single byte.
.TP
.BL X Backspace
Delete the byte before the cursor, moving the rest of the file
left by a single byte.
.TP
.BL F2 W
Invoke \fB:w\fP.
.TP
.BL F10 Z
Invoke \fB:x\fP.
.TP
.BL Q
Invoke \fB:q\fP.
.PD


.SH EXMODE

.TP
.BL r read
Read a file from disk and insert it at the cursor position.
If a region is selected, replace the region with the file.
.TP
.BL w write
Save the file to disk. If a region is selected, save the region
to a separate file (you will be prompted for the name).
.TP
.BL ! pipe
Pipe the selected region through a given command
(you will be prompted for the name).
.TP
.BL q quit
Quit without saving the file.
.TP
.BL x exit
Save the file if modified, and then quit.
.TP
.BL swp
Save a swap file to disk. It is a dump containing only unsaved
blocks thus it is efficient even for very large files (if you
haven't made very large changes, obviously) and can be used
to restore your work shall you have no chance to save your file
properly later.
.TP
.BL s substitute
Substitute given search expression by another expression at the
first match. ". is empty in the other expression.
(TODO: represent the seq being subst'd.)
.TP
.BL S substall
Substitute all matches of given search expression from cursor
to the end of file by another expression. Otherwise same as \f3s\f1.
.TP
.BL ie ieval
Evaluate expression and insert result at the cursor position.
.TP
.BL pe peval
Evaluate expression and print it.
.TP
.BL re reval
Evaluate expression and fill the selected region with the result.
See
.SB EXPRESSIONS
below for more details.
.TP
.BL width
Change number of bytes per line.
.TP
.BL endian
Toggle between big-endian and little-endian values in the status
line. The default when started is the native endianity of the
machine.


.SH EXPRESSIONS

.B Hed
employs the powerful concept of "expressions" at various places
(e.g. when searching). An expression can be arbitrarily long
and is composed of atoms pasted together (whitespaces can appear
anywhere between atoms; you might \fIneed\fP whitespaces to make
sure the atom boundary is unambiguous). Each atom can span an
arbitrary number of bytes and the result of the whole expression
is a string of bytes produced by the atoms. Arithmetic operations
work on signed integers. The sign bit is not part of the expression
result (hence 255 occupies only 1 byte, not 2 bytes, for instance),
but it is used during evaluation. All basic expressions (numbers,
strings, etc.) are positive. A negative number may be produced
either with a unary minus or by subtracting a larger number from
a smaller one.

An atom can be either:
.TP
.BI ( atom )
Yes, you can use parentheses, isn't that cool?
.TP
.IB atom[ . ]suffix
Override the size of \fIatom\fP according to the suffix (the suffix can
be uppercase or lowercase without any change in meaning):
.RS
.TP
.B B
1 byte (\fBB\fPyte)
.PD 0
.TP
.B W
2 bytes (\fBW\fPord)
.TP
.B D
4 bytes (\fBD\fPouble-word)
.TP
.B Q
8 bytes (\fBQ\fPuad-word)
.TP
.BI { len }
exactly \fIlen\fP bytes
.RE
.PD
.IP
As a courtesy to gas users, \fBL\fP is recognized as an alias of \f3D\f1.

The dot can be omitted in most cases, but it must be used when
the suffix would be parsed as part of \fIatom\fP, e.g. \fB0x70d\fP
is the two-byte hexadecimal constant 0x70d with no suffix rather
than 0x70 resized to 4 bytes.
.TP
.I unop atom
You can apply a unary operation \fIunop\fP on an atom. Currently only
\fB~\fP (bit negation) and \fB-\fP (arithmetic negation) is
supported.
.TP
.I atom binop atom
You can produce an atom by performing a binary operation \fIbinop\fP on
two subatoms. If they don't have the same length, the missing
bytes are sign-extended. Supported binary operators, listed from highest
to lowest precedence:
.RS
.TP
.B * / %
.PD 0
.TP
.B + -
.TP
.B >> <<
.TP
.B &
.TP
.B ^
.TP
.B |
.RE
.PD
.IP
All operators are left-associative.
.B Hed
implements all these operations on numbers of arbitrary size.
.TP
.BI \' "ASCII_string" \'
Just like that. Prefix any apostrophes and backslashes by a
backslash.
.TP
.IB dec_digit ...
Decimal number. It takes the minimum number of bytes necessary to represent
the number.
.TP
.BI 0b bin_digit ...
Binary number.
.TP
.BI 0 oct_digit ...
Octal number.
.TP
.BI 0x hex_digit ...
Hexadecimal number.
Note that this is a \fInumber\fP, so it is transformed for endianity and any
leading zeroes are ignored.
.TP
.BI x hex_digit ...
This is a \fIbyte sequence\fP of arbitrary length. The difference from a
hexadecimal number is that it is not flipped for endianity.
.TP
.BI @ x
Mark \fIx\fP as a sizeof(off_t) byte number. There are also two special marks:
\fB$\fP for cursor position and \fB.\fP for position of the currently
matched content (available only during a search).
.TP
.BI """" x
Register \fIx\fP as a byte sequence. Through this, you can have access
to any clipboard register.
Note that this byte sequence is fixed-size! It is actually auto-sized to fit
the parent expression width for binary operations, and defaults to one byte.

There are a few special registers:
.RS
.PD 0
.TP 3
.B $
content under cursor
.TP
.B _
content from the beginning of the file
.TP
.B .
content being matched (available only during a search)
.RE
.PD
.IP
The current match register \fB".\fP can be used for smart searches
and replaces, e.g.:
.RS
.TP
.B /'asdf'".'hjkl'\fP
Search for the strings \fB'asdf'\fP and \fB'hjkl'\fP with any byte
between them.
.TP
.B /xf0f0f0&".
Search for a sequence of three bytes with low nibbles not set.
.TP
.B ":re "".|0x8000"
Set the highest bit of every other selected byte.
.TP
.B ":re (("".&0xff00)>>8)|(("".&0x00ff)<<8)"
Swap pairs of bytes.
.RE
.TP
.BI """" x [ offset ]
Contents of register \fIx\fP (see above) at a given \fIoffset\fP.
The offset is a full-fledged expression, interpreted as a number,
and it can be negative. For the current match register \fB".\fP,
the offset can refer to bytes outside the range.

.SH CONFIGURATION
.B Hed
reads it configuration file from
.I /etc/hedrc
and
.I ~/.hedrc.
The file is parsed for lines in the form "set option value". For
boolean options, value 0 or false is recognized as false, any
other value (including no value at all) is recognied as true.
These are the supported options:

.TP
.B default_mode
Either normal, insert or replace.
.TP
.B bytes_per_line
Number of bytes to show per line, unless '-s' option was specified
on the command line. If not set, computed based on screen width
(to the nearest less multiply of 0x10).


.SH LICENSE
.B Hed
is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License
as published by the Free Software Foundation.

.SH AUTHOR
.I Hed
was written by 
.B Petr Baudis
<pasky@ucw.cz>.
See file 
.I AUTHORS
for a list of people contributing to this project.
.P
The homepage of \fBhed\fP can be found at
.BI http://www.tesarici.cz/dev/hed/

.SH "SEE ALSO"
.BR hexedit (1),
.BR hexdump (1),
.BR od (1)
